!- TRIANGULAR μOS 1.11 for Commodore VIC-20 5KB
!- MONITOR


!- Set variables
0 print"{clear}{142}":poke36879,104:q$=chr$(34):dimrn(3):dimhe(3):dimhe$(3):dimdc(3):as$="start address":bd=peek(900)

!- Command loop
1 gosub11
2 in$="":ip$="*":gosub43:ifin$="exit"then15
3 ifin$="clr"then1
4 ifin$="entry"then16
5 ifin$="copy"then31
6 ifin$="fill"then56
7 ifin$="show"then66
8 ifin$="help"thengosub83
9 ifin$="go"then12
10 print"{down} {yellow}invalid command!{white}":goto2

!- Main title
11 print"{clear}{purple}{cm asterisk}{reverse on}  {reverse off}{sh pound}{cyan}triangular monitor{purple} {cm asterisk}{sh pound}{cyan} (c)2023{white}":return

!- Go
12 ip$=as$:gosub44:ifr=2then2
13 hl=4:gosub25:ifr=1then12
14 sysdc:goto2

!- Load apps (exit)
15 print"{clear}":poke36879,8:print"{down*12}"tab(8)"{purple}{cm asterisk}{reverse on}    {reverse off}{sh pound}{down}{left*5}{cm asterisk}{reverse on}  {reverse off}{sh pound}{down}{left*3}{cm asterisk}{sh pound}{return}{down*2}{white}     {cm @*12}{return}{white}    {cm m}{reverse on}{blue}{cm m*7}{reverse off}     {white}{cm g}{return}{white}     {cm t*12}{return}{white}{down}      loading...{home}{black}load "q$"apps"q$","bd:poke198,.:fori=.to5:g=peek(980+i):poke631+i,g:nexti:poke198,6:new

!- Entry
16 ip$=as$:gosub44:ifr=2then2
17 hl=4:gosub25:ifr=1then16
18 ad=dc:hl=2
19 ot=ad:gosub50
20 ip$="address "+hw$:gosub44:ifin$="r"then23
21 ifr=2then2
22 gosub25:ifr=1then20
23 pokead,dc
24 ad=ad+1:goto19

!- Max digit test
25 r=.:dc=.:nl=len(in$):ifnl>hlthenprint"{down}{yellow} max"hl"digits!{white}":r=1:return
26 r=.:fori=1tonl:td$=mid$(in$,i,1):tn=asc(td$):iftn>47andtn<58thentd=tn-48:goto29
27 iftn>64andtn<71thentd=tn-55:goto29
28 r=1
29 dc=dc+(td*(16^(nl-i))):nexti:ifr=1thenprint"{down} {yellow}invalid hex number!{white}":return
30 return

!- Copy
31 ip$="copy from 1st address{return}":gosub44:ifr=2then2
32 hl=4:gosub25:ifr=1then31
33 a1=dc
34 ip$="copy from 2st address{return}":gosub44:ifr=2then2
35 gosub25:ifr=1then34
36 ifdc<a1thenprint"{down} 2nd address lower than 1st!":goto34
37 a2=dc
38 ip$="copy to address":gosub44:ifr=2then2
39 gosub25:ifr=1then38
40 ad=dc
41 j=.:fori=a1toa2:mv=peek(i):if(ad+j)>65535thenj=j-1
42 pokead+j,mv:j=j+1:nexti:goto2

!- Command entry
43 print"{down}"ip$":";:open1,.:input#1,in$:close1:print"{white}{reverse off}":return

!- Entry adress
44 r=.:gosub43:gosub48:ifr=1orr=2thenreturn
45 return

!- Stop on X
46 r=.:gosub48:ifr=1orr=2thenreturn
47 return

!- Check for X-stop
48 ifin$="x"thenr=2:return
49 return

!- Convert hex to dec
50 he(.)=int(ot/4096):he(1)=int((ot-(he(.)*4096))/256)
51 he(2)=int((ot-(he(.)*4096)-(he(1)*256))/16)
52 he(3)=ot-(he(.)*4096)-(he(1)*256)-(he(2)*16)
53 forg=.to3:ifhe(g)<10thenhe$(g)=chr$(48+he(g))
54 ifhe(g)>9thenhe$(g)=chr$(55+he(g))
55 nextg:hw$=he$(.)+he$(1)+he$(2)+he$(3):return

!- Fill
56 ip$="fill 1st address":gosub44:ifr=2then2
57 hl=4:gosub25:ifr=1then59
58 a1=dc
59 ip$="fill 2nd address":gosub44:ifr=2then2
60 gosub25:ifr=1then59
61 ifdc<a1thenprint"{down} 2nd address lower than 1st!":goto59
62 a2=dc
63 ip$="fill memory value":gosub44:gosub46:ifr=2then2
64 hl=2:gosub25:ifr=1then63
65 mv=dc:fori=a1toa2:pokei,mv:nexti:goto2

!- Show
66 ip$=as$:gosub44:ifr=2then2
67 hl=4:gosub25:ifr=1then66
68 ad=dc
69 ifad<.thenad=.
70 ifad>65520thenad=65520
71 gosub11:fori=.to15step2:ot=ad+i:gosub50:print"{down} "hw$":";:ot=peek(ad+i)
72 gosub50:printright$(hw$,2);,;:ot=ad+i+1:gosub50:print" "hw$":";
73 ot=peek(ad+i+1):gosub50:printright$(hw$,2):nexti
74 print"{down*2} {green}{reverse on}f1{cyan}{reverse off} <  {green}{reverse on}f2{cyan}{reverse off} >  {yellow}{reverse on}f8{cyan}{reverse off} stop{white}"
75 geta$:ifa$="{f2}"thenad=ad+16:goto69
76 ifa$="{f1}"thenad=ad-16:goto69
77 ifa$="{f8}"then2
78 goto75

!- F1 to continue & F8 to stop
79 print"{down*2} {green}{reverse on}f1{reverse off}{cyan} to continue{down}{return} {yellow}{reverse on}f8{reverse off}{cyan} to stop";
80 getk$:ifk$="{f1}"thenreturn
81 ifk$="{f8}"thent=1:return
82 goto80

!- Help
83 gosub11:print"{down*2} monitor help:{return}{down*2} help - show help{return}{down} exit - quit to{return}"tab(8)"desktop{return}{down} entry - entry values{return}","{left*2}to memory{return}{down} show - show memory{return}","{left*3}content":t=.:gosub79:ift=1then1
84 gosub11:print"{down*2} monitor help:{return}{down*2} fill - fill memory{return}","{left*3}block{return}{down*2} copy - copy memory{return}","{left*3}block{return}{down} go - run assembler{return}"tab(6)"program":t=.:gosub79:ift=1then1
85 gosub11:print"{down*2} monitor help:{return}{down} clr - clears screen{return}{down*2} x - cancel entering{return}{right*5}numbers{return}{down} r - in entry mode{return}     repeat previous{return}     value":gosub79:goto1
